#!/usr/bin/python3
from types import FunctionType

def to_value(a, var_list):
	if isinstance(a, FunctionType):
		return a(var_list)
	return a
# 运行函数
def run(*args):
	var_list={}
	for arg in args:
		var_list = arg(var_list)
# 定次循环
def repeat(times, *args):
	def f(var_list):
		for i in range(times):
			for arg in args:
				var_list = arg(var_list)
		return var_list
	return f
# 打印
def display(*args):
	def f(var_list):
		for arg in args:
			print(to_value(arg, var_list), end="")
		return var_list
	return f
# 换行
def newline():
	def f(var_list):
		print("")
		return var_list
	return f
# 设置变量
def set_value(k, v):
	def f(var_list):
		var_list[k] = to_value(v, var_list);
		return var_list
	return f
# 获得变量
def get_value(k):
	return lambda var_list : var_list[k];
# 二元运算
def op(a, b, f):
	return lambda var_list: f(to_value(a,var_list), to_value(b,var_list))
# 比较可以用cmp
def cmp(a, s, b):
	ops = {
		"<" : lambda x,y:x<y,
		">" : lambda x,y:x>y,
		"<=" : lambda x,y:x<=y,
		">=" : lambda x,y:x>=y,
		"=" : lambda x,y:x==y,
		"!=" : lambda x,y:x!=y,
	}
	return op(a,b,ops[s])
# 比较也可以不用cmp，而用下面六个函数
# <
def lt(a, b):
	return cmp(a, "<", b)
# >
def gt(a, b):
	return cmp(a, ">", b)
# <=
def le(a, b):
	return cmp(a, "<=", b)
# >=
def ge(a, b):
	return cmp(a, ">=", b)
# =
def eq(a, b):
	return cmp(a, "=", b) 
# !=
def ne(a, b):
	return cmp(a, "!=", b)
# +
def add(a, b):
	return op(a,b,lambda x,y:x+y)
# -
def sub(a, b):
	return op(a,b,lambda x,y:x-y)
# *
def mul(a, b):
	return op(a,b,lambda x,y:x*y)
# not
def NOT(a):
	return lambda var_list: not a(var_list)
# and
def AND(a, b):
	return lambda var_list: False if not a(var_list) else b(var_list)
# or
def OR(a, b):
	return lambda var_list: True if a(var_list) else b(var_list)
# square
def square(a):
	return mul(a, a)
# /
def div(a, b):
	return op(a,b,lambda x,y:x//y)
# %
def mod(a, b):
	return op(a,b,lambda x,y:x%y)
# 以下为过程式编程常用的三个流控制关键字建模
# 返回一个整数，用数字来判断这三个关键字
def BREAK():
	return 0
def CONTINUE():
	return 1
def ELSE():
	return 2
# if
def IF(cond, *args):
	def f(var_list):
		if cond(var_list):
			for arg in args:
				if isinstance(arg, int):
					if arg==2: #ELSE
						break
					return (arg, var_list)
				x = arg(var_list)
				if isinstance(x, tuple):
					return x
				var_list = x
		else:
			b = False
			for arg in args:
				if b:
					if isinstance(arg, int):
						return (arg, var_list)
					x = arg(var_list)
					if isinstance(x, tuple):
					 	return x
					var_list = x
				else:
					if isinstance(arg, int) and arg==2: #ELSE
						b = True
		return var_list
	return f
# while
def WHILE(cond, *args):
	def f(var_list):
		while cond(var_list):
			for arg in args:
				if arg == 0: #BREAK
					return var_list
				elif arg == 1: #CONTINUE
					break
				x = arg(var_list)
				if isinstance(x, tuple):
					if x[0] == 0: #BREAK
						return x[1]
					elif x[0] == 1: #CONTINUE
						var_list = x[1]
						break
				else:
				 	var_list = x
		return var_list
	return f

if __name__ == '__main__':
	run(
		display("2"),
		set_value("i",3),
		WHILE(lt(get_value("i"), 100),
			set_value("flag", 0),
			set_value("j",3),
			WHILE(le(square(get_value("j")), get_value("i")),
				IF(eq(mod(get_value("i"), get_value("j")), 0),
					set_value("flag", 1),
					BREAK(),
				ELSE(),
					set_value("j", add(get_value("j"), 2))
				)
			),
			IF(eq(get_value("flag") ,0),
				display(","),
				display(get_value("i"))
			),
			set_value("i", add(get_value("i"), 2))
		),
		newline()
	)
